# Ignite UI for WebComponents FDC3 Data Adapter - from Infragistics

[Ignite UI for Web Components](https://www.infragistics.com/products/ignite-ui-WebComponents) is a complete set of UI Widgets, Components extending the browser's native capabilities by Infragistics. Ignite UI for WebComponents is designed to enable developers to build the most modern, high-performance HTML5 & JavaScript apps for modern desktop browsers, mobile experiences and progressive web apps (PWA’s) with native custom elements.

This package provides the FDC3 Data Adapter that generates financial data for received [FDC3 intents](https://fdc3.finos.org/docs/1.0/intents-intro) as well as sending messages to other FDC3-enabled apps using [OpenFin FDC3 service](https://developers.openfin.co/docs/fdc3). This data adapter can be used with [Ignite UI for WebComponents Charts](https://www.npmjs.com/package/igniteui-webcomponents-charts) and [Ignite UI for WebComponents Grids](https://www.npmjs.com/package/igniteui-webcomponents-grids).


<!-- commented out because we dont have a sample for Web Components version yet -->
<!-- ## [**View running samples here**](https://www.infragistics.com/resources/sample-applications/webcomponents-stock-chart-app) -->


## NPM Package

You can include Ignite UI for Web Components Charts in your project using this `npm` command:

`npm install --save igniteui-webcomponents-fdc3 igniteui-webcomponents-core`

## License
This is a commercial product, requiring a valid paid-for license for use. This license details can by found [here](http://www.infragistics.com/legal/ultimate/license/)

To acquire a license for usage, please register for a trial and acquire a license at [Infragistics.com](https://www.infragistics.com).

© Copyright 2023 Infragistics. All Rights Reserved. The Infragistics Ultimate license & copyright applies to this distribution. For information on that license, please go to our website [here](https://www.infragistics.com/legal/license).
