/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, String_$type, fromEnum, markType } from "igniteui-webcomponents-core";
import { Dictionary$2 } from "igniteui-webcomponents-core";
import { List$1 } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let Fdc3Dictionary = /*@__PURE__*/ (() => {
    class Fdc3Dictionary extends Base {
        constructor() {
            super();
            this.d = null;
            this.d = new Dictionary$2(String_$type, Base.$, 0);
        }
        getKeys() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.d)) {
                a.add(b.key);
            }
            return a.toArray();
        }
        getValues() {
            let a = new List$1(Base.$, 0);
            for (let b of fromEnum(this.d)) {
                a.add1(b.value);
            }
            return a.toArray();
        }
        item(a, b) {
            if (arguments.length === 2) {
                this.set(a, b);
                return b;
            }
            else {
                return this.get(a);
            }
        }
        get(a) {
            if (!this.d.containsKey(a)) {
                this.set(a, "");
            }
            if (this.d.item(a) == null) {
                return "";
            }
            return this.d.item(a);
        }
        h(a) {
            return this.get(a).toString();
        }
        e(a) {
            if (!this.d.containsKey(a)) {
                this.set(a, 0);
                return 0;
            }
            if (this.d.item(a) == null) {
                return 0;
            }
            return parseFloat(this.d.item(a).toString());
        }
        set(a, b) {
            if (this.d.containsKey(a)) {
                this.d.item(a, b);
            }
            else {
                this.d.addItem(a, b);
            }
        }
        remove(a) {
            if (this.d.containsKey(a)) {
                this.d.removeItem(a);
            }
        }
        contains(a) {
            return this.d.containsKey(a);
        }
    }
    Fdc3Dictionary.$t = /*@__PURE__*/ markType(Fdc3Dictionary, 'Fdc3Dictionary');
    return Fdc3Dictionary;
})();
