/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, callStaticConstructors, String_$type, EnumUtil, markType } from "igniteui-webcomponents-core";
import { Dictionary$2 } from "igniteui-webcomponents-core";
import { Fdc3ContextType_$type } from "./Fdc3ContextType";
import { Fdc3IntentType_$type } from "./Fdc3IntentType";
/**
 * @hidden
 */
export let Fdc3Util = /*@__PURE__*/ (() => {
    class Fdc3Util extends Base {
        static staticInit() {
            Fdc3Util.c = new Dictionary$2(String_$type, Fdc3ContextType_$type, 0);
            Fdc3Util.f(0);
            Fdc3Util.f(1);
            Fdc3Util.f(2);
            Fdc3Util.f(3);
            Fdc3Util.f(4);
            Fdc3Util.f(7);
            Fdc3Util.f(8);
            Fdc3Util.f(5);
            Fdc3Util.f(6);
            Fdc3Util.d = new Dictionary$2(String_$type, Fdc3IntentType_$type, 0);
            Fdc3Util.g(2);
            Fdc3Util.g(3);
            Fdc3Util.g(4);
            Fdc3Util.g(7);
            Fdc3Util.g(5);
            Fdc3Util.g(6);
            Fdc3Util.g(8);
            Fdc3Util.g(10);
            Fdc3Util.g(9);
        }
        static getString(a) {
            let b = EnumUtil.getName(Fdc3ContextType_$type, a);
            return "fdc3." + b.substr(0, 1).toLowerCase() + b.substr(1);
        }
        static a(a) {
            if (Fdc3Util.c.containsKey(a)) {
                return Fdc3Util.c.item(a);
            }
            else {
                return 0;
            }
        }
        static b(a) {
            if (Fdc3Util.d.containsKey(a)) {
                return Fdc3Util.d.item(a);
            }
            else {
                return 2;
            }
        }
        static f(a) {
            let b = Fdc3Util.getString(a);
            if (!Fdc3Util.c.containsKey(b)) {
                Fdc3Util.c.addItem(b, a);
            }
        }
        static g(a) {
            let b = EnumUtil.getName(Fdc3IntentType_$type, a);
            if (!Fdc3Util.d.containsKey(b)) {
                Fdc3Util.d.addItem(b, a);
            }
        }
    }
    Fdc3Util.$t = /*@__PURE__*/ markType(Fdc3Util, 'Fdc3Util');
    Fdc3Util.c = null;
    Fdc3Util.d = null;
    return Fdc3Util;
})();
(function (v) { callStaticConstructors(); })(true);
