/*!
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
  */
  
import { markEnum, Base, Dictionary$2, String_$type, List$1, fromEnum, markType, EnumUtil, callStaticConstructors, StringBuilder, typeCast, stringIsNullOrEmpty, Boolean_$type, enumGetBox, FinancialDataAdapter, arrayClear, IDisposable_$type, truncate, Random } from 'igniteui-webcomponents-core';

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Specifies type of FDC3 intent
 *  https://fdc3.finos.org/docs/1.0/intents-spec
 *
 */
var Fdc3IntentType = /*@__PURE__*/ (function (Fdc3IntentType) {
    /**
     * Specifies no intent for FDC3 data adapter to listen to
     */
    Fdc3IntentType[Fdc3IntentType["None"] = 0] = "None";
    /**
     * Specifies all intents for FDC3 data adapter to listen to
     */
    Fdc3IntentType[Fdc3IntentType["All"] = 1] = "All";
    /**
     * Specifies an intent that is unknown by FDC3 data adapter
     */
    Fdc3IntentType[Fdc3IntentType["Unknown"] = 2] = "Unknown";
    /**
     * Specifies an intent to view a chart for stock tickers in the Instrument context
     */
    Fdc3IntentType[Fdc3IntentType["ViewChart"] = 3] = "ViewChart";
    /**
     * Specifies an intent to view information about stock tickers in the Instrument context
     */
    Fdc3IntentType[Fdc3IntentType["ViewInstrument"] = 4] = "ViewInstrument";
    /**
     * Currently not supported - Starts a call with Contact(s) context
     */
    Fdc3IntentType[Fdc3IntentType["StartCall"] = 5] = "StartCall";
    /**
     * Currently not supported - Starts a chat with Contact(s) context
     */
    Fdc3IntentType[Fdc3IntentType["StartChat"] = 6] = "StartChat";
    /**
     * Currently not supported - Display analysis about Instrument, Contact, or Organization
     */
    Fdc3IntentType[Fdc3IntentType["ViewAnalysis"] = 7] = "ViewAnalysis";
    /**
     * Currently not supported - Display details of the Contact context
     */
    Fdc3IntentType[Fdc3IntentType["ViewContact"] = 8] = "ViewContact";
    /**
     * Currently not supported - Display news for Instrument, Contact, or Organization
     */
    Fdc3IntentType[Fdc3IntentType["ViewNews"] = 9] = "ViewNews";
    /**
     * Currently not supported - Display pricing for the Instrument context
     */
    Fdc3IntentType[Fdc3IntentType["ViewQuote"] = 10] = "ViewQuote";
    return Fdc3IntentType;
})({});
/**
 * @hidden
 */
let Fdc3IntentType_$type = /*@__PURE__*/ markEnum('Fdc3IntentType', 'None,0|All,1|Unknown,2|ViewChart,3|ViewInstrument,4|StartCall,5|StartChat,6|ViewAnalysis,7|ViewContact,8|ViewNews,9|ViewQuote,10');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Fdc3Dictionary = /*@__PURE__*/ (() => {
    class Fdc3Dictionary extends Base {
        constructor() {
            super();
            this.d = null;
            this.d = new Dictionary$2(String_$type, Base.$, 0);
        }
        getKeys() {
            let a = new List$1(String_$type, 0);
            for (let b of fromEnum(this.d)) {
                a.add(b.key);
            }
            return a.toArray();
        }
        getValues() {
            let a = new List$1(Base.$, 0);
            for (let b of fromEnum(this.d)) {
                a.add1(b.value);
            }
            return a.toArray();
        }
        item(a, b) {
            if (arguments.length === 2) {
                this.set(a, b);
                return b;
            }
            else {
                return this.get(a);
            }
        }
        get(a) {
            if (!this.d.containsKey(a)) {
                this.set(a, "");
            }
            if (this.d.item(a) == null) {
                return "";
            }
            return this.d.item(a);
        }
        h(a) {
            return this.get(a).toString();
        }
        e(a) {
            if (!this.d.containsKey(a)) {
                this.set(a, 0);
                return 0;
            }
            if (this.d.item(a) == null) {
                return 0;
            }
            return parseFloat(this.d.item(a).toString());
        }
        set(a, b) {
            if (this.d.containsKey(a)) {
                this.d.item(a, b);
            }
            else {
                this.d.addItem(a, b);
            }
        }
        remove(a) {
            if (this.d.containsKey(a)) {
                this.d.removeItem(a);
            }
        }
        contains(a) {
            return this.d.containsKey(a);
        }
    }
    Fdc3Dictionary.$t = /*@__PURE__*/ markType(Fdc3Dictionary, 'Fdc3Dictionary');
    return Fdc3Dictionary;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Specifies type of FDC3 context
 *  https://fdc3.finos.org/docs/1.0/context-spec
 *
 */
var Fdc3ContextType = /*@__PURE__*/ (function (Fdc3ContextType) {
    /**
     * Specifies a context that is unknown by FDC3 data adapter
     */
    Fdc3ContextType[Fdc3ContextType["Unknown"] = 0] = "Unknown";
    /**
     * Specifies FDC3 context for single instrument with stock name, stock ticker/symbol
     */
    Fdc3ContextType[Fdc3ContextType["Instrument"] = 1] = "Instrument";
    /**
     * Specifies FDC3 context for multiple instrument
     */
    Fdc3ContextType[Fdc3ContextType["InstrumentList"] = 2] = "InstrumentList";
    /**
     * Specifies FDC3 context for single position
     */
    Fdc3ContextType[Fdc3ContextType["Position"] = 3] = "Position";
    /**
     * Specifies FDC3 context for multiple positions
     */
    Fdc3ContextType[Fdc3ContextType["Portfolio"] = 4] = "Portfolio";
    /**
     * Currently not supported - Specifies FDC3 context for single contact with person name, email, phone, etc.
     */
    Fdc3ContextType[Fdc3ContextType["Contact"] = 5] = "Contact";
    /**
     * Currently not supported - Specifies FDC3 context for multiple contacts
     */
    Fdc3ContextType[Fdc3ContextType["ContactList"] = 6] = "ContactList";
    /**
     * Currently not supported - Specifies FDC3 context for single organization with company name
     */
    Fdc3ContextType[Fdc3ContextType["Organization"] = 7] = "Organization";
    /**
     * Currently not supported - Specifies FDC3 context for multiple organizations
     */
    Fdc3ContextType[Fdc3ContextType["OrganizationList"] = 8] = "OrganizationList";
    return Fdc3ContextType;
})({});
/**
 * @hidden
 */
let Fdc3ContextType_$type = /*@__PURE__*/ markEnum('Fdc3ContextType', 'Unknown,0|Instrument,1|InstrumentList,2|Position,3|Portfolio,4|Contact,5|ContactList,6|Organization,7|OrganizationList,8');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Fdc3Util = /*@__PURE__*/ (() => {
    class Fdc3Util extends Base {
        static staticInit() {
            Fdc3Util.c = new Dictionary$2(String_$type, Fdc3ContextType_$type, 0);
            Fdc3Util.f(0);
            Fdc3Util.f(1);
            Fdc3Util.f(2);
            Fdc3Util.f(3);
            Fdc3Util.f(4);
            Fdc3Util.f(7);
            Fdc3Util.f(8);
            Fdc3Util.f(5);
            Fdc3Util.f(6);
            Fdc3Util.d = new Dictionary$2(String_$type, Fdc3IntentType_$type, 0);
            Fdc3Util.g(2);
            Fdc3Util.g(3);
            Fdc3Util.g(4);
            Fdc3Util.g(7);
            Fdc3Util.g(5);
            Fdc3Util.g(6);
            Fdc3Util.g(8);
            Fdc3Util.g(10);
            Fdc3Util.g(9);
        }
        static getString(a) {
            let b = EnumUtil.getName(Fdc3ContextType_$type, a);
            return "fdc3." + b.substr(0, 1).toLowerCase() + b.substr(1);
        }
        static a(a) {
            if (Fdc3Util.c.containsKey(a)) {
                return Fdc3Util.c.item(a);
            }
            else {
                return 0;
            }
        }
        static b(a) {
            if (Fdc3Util.d.containsKey(a)) {
                return Fdc3Util.d.item(a);
            }
            else {
                return 2;
            }
        }
        static f(a) {
            let b = Fdc3Util.getString(a);
            if (!Fdc3Util.c.containsKey(b)) {
                Fdc3Util.c.addItem(b, a);
            }
        }
        static g(a) {
            let b = EnumUtil.getName(Fdc3IntentType_$type, a);
            if (!Fdc3Util.d.containsKey(b)) {
                Fdc3Util.d.addItem(b, a);
            }
        }
    }
    Fdc3Util.$t = /*@__PURE__*/ markType(Fdc3Util, 'Fdc3Util');
    Fdc3Util.c = null;
    Fdc3Util.d = null;
    return Fdc3Util;
})();
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Fdc3Serializer = /*@__PURE__*/ (() => {
    class Fdc3Serializer extends Base {
        constructor() {
            super();
            this._sb = null;
            this.m = 0;
            this.l = false;
            this._sb = new StringBuilder(0);
        }
        toString() {
            return this._sb.toString();
        }
        toJson(a) {
            this._sb.v();
            if (typeCast(Fdc3Instrument.$, a) !== null) {
                this.add4(typeCast(Fdc3Instrument.$, a));
            }
            else if (typeCast(Fdc3InstrumentList.$, a) !== null) {
                this.add5(typeCast(Fdc3InstrumentList.$, a));
            }
            else if (typeCast(Fdc3Position.$, a) !== null) {
                this.add9(typeCast(Fdc3Position.$, a));
            }
            else if (typeCast(Fdc3Portfolio.$, a) !== null) {
                this.add8(typeCast(Fdc3Portfolio.$, a));
            }
            else if (typeCast(Fdc3Contact.$, a) !== null) {
                this.add1(typeCast(Fdc3Contact.$, a));
            }
            else if (typeCast(Fdc3ContactList.$, a) !== null) {
                this.add2(typeCast(Fdc3ContactList.$, a));
            }
            else if (typeCast(Fdc3Organization.$, a) !== null) {
                this.add6(typeCast(Fdc3Organization.$, a));
            }
            else if (typeCast(Fdc3OrganizationList.$, a) !== null) {
                this.add7(typeCast(Fdc3OrganizationList.$, a));
            }
            else {
                this.add3(typeCast(Fdc3Context.$, a));
            }
            return this.toString();
        }
        add4(a, b = "") {
            this.z("serializing Fdc3Instrument");
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let e = a.getKeys();
            for (let d = 0; d < e.length; d++) {
                let c = e[d];
                if (c == "type") {
                    continue;
                }
                if (c == "name") {
                    continue;
                }
                if (c == "target") {
                    continue;
                }
                if (c == "intent") {
                    continue;
                }
                if (c == "ticker") {
                    continue;
                }
                if (c != "id") {
                    this.addProp1(c, a.item(c));
                }
            }
            if (a.id == null) {
                this.addProp1("id", "null");
            }
            else {
                this.addProp("id");
                this.addObjectOpen();
                this.addProp1("ticker", a.ticker);
                let h = a.id.getKeys();
                for (let g = 0; g < h.length; g++) {
                    let f = h[g];
                    if (f == "ticker") {
                        continue;
                    }
                    this.addProp1(f, a.id.item(f));
                }
                this.addObjectClose();
            }
            this.addObjectClose(b);
        }
        add5(a) {
            this.z("serializing Fdc3InstrumentList");
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let d = a.getKeys();
            for (let c = 0; c < d.length; c++) {
                let b = d[c];
                if (b == "type") {
                    continue;
                }
                if (b == "name") {
                    continue;
                }
                if (b == "target") {
                    continue;
                }
                if (b == "intent") {
                    continue;
                }
                if (b == "id") {
                    continue;
                }
                if (b != "instruments") {
                    this.addProp1(b, a.item(b));
                }
            }
            if (a.instruments == null) {
                this.addProp1("instruments", "null");
            }
            else {
                this.addProp("instruments");
                this.addArrayOpen();
                let g = a.instruments;
                for (let f = 0; f < g.length; f++) {
                    let e = g[f];
                    this.add4(e, ",");
                }
                this.addArrayClose();
            }
            this.addObjectClose();
        }
        add8(a) {
            this.z("serializing Fdc3Portfolio");
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let d = a.getKeys();
            for (let c = 0; c < d.length; c++) {
                let b = d[c];
                if (b == "type") {
                    continue;
                }
                if (b == "name") {
                    continue;
                }
                if (b == "target") {
                    continue;
                }
                if (b == "intent") {
                    continue;
                }
                if (b == "id") {
                    continue;
                }
                if (b != "positions") {
                    this.addProp1(b, a.item(b));
                }
            }
            if (a.positions == null) {
                this.addProp1("positions", "null");
            }
            else {
                this.addProp("positions");
                this.addArrayOpen();
                let g = a.positions;
                for (let f = 0; f < g.length; f++) {
                    let e = g[f];
                    this.add9(e, ",");
                }
                this.addArrayClose();
            }
            this.addObjectClose();
        }
        add9(a, b = "") {
            this.z("serializing Fdc3Position");
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let e = a.getKeys();
            for (let d = 0; d < e.length; d++) {
                let c = e[d];
                if (c == "type") {
                    continue;
                }
                if (c == "name") {
                    continue;
                }
                if (c == "target") {
                    continue;
                }
                if (c == "intent") {
                    continue;
                }
                if (c == "id") {
                    continue;
                }
                if (c != "instrument") {
                    this.addProp1(c, a.item(c));
                }
            }
            if (a.instrument == null) {
                this.addProp1("instrument", "null");
            }
            else {
                this.addProp("instrument");
                this.add4(a.instrument, ",");
            }
            this.addObjectClose(b);
        }
        add1(a, b = "") {
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let e = a.getKeys();
            for (let d = 0; d < e.length; d++) {
                let c = e[d];
                if (c == "type") {
                    continue;
                }
                if (c == "name") {
                    continue;
                }
                if (c == "target") {
                    continue;
                }
                if (c == "intent") {
                    continue;
                }
                if (c == "email") {
                    continue;
                }
                if (c == "phone") {
                    continue;
                }
                if (c != "id") {
                    this.addProp1(c, a.item(c));
                }
            }
            if (a.id == null) {
                this.addProp1("id", "null");
            }
            else {
                this.addProp("id");
                this.addObjectOpen();
                let h = a.id.getKeys();
                for (let g = 0; g < h.length; g++) {
                    let f = h[g];
                    this.addProp1(f, a.id.item(f));
                }
                this.addObjectClose();
            }
            this.addObjectClose(b);
        }
        z(message_) {
        }
        add2(a) {
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let d = a.getKeys();
            for (let c = 0; c < d.length; c++) {
                let b = d[c];
                if (b == "type") {
                    continue;
                }
                if (b == "name") {
                    continue;
                }
                if (b == "target") {
                    continue;
                }
                if (b == "intent") {
                    continue;
                }
                if (b == "id") {
                    continue;
                }
                if (b != "contacts") {
                    this.addProp1(b, a.item(b));
                }
            }
            if (a.contacts == null) {
                this.addProp1("contacts", "null");
            }
            else {
                this.addProp("contacts");
                this.addArrayOpen();
                let g = a.contacts;
                for (let f = 0; f < g.length; f++) {
                    let e = g[f];
                    this.add1(e, ",");
                }
                this.addArrayClose();
            }
            this.addObjectClose();
        }
        add6(a, b = "") {
            this.z("serializing Fdc3Organization");
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let e = a.getKeys();
            for (let d = 0; d < e.length; d++) {
                let c = e[d];
                if (c == "type") {
                    continue;
                }
                if (c == "name") {
                    continue;
                }
                if (c == "target") {
                    continue;
                }
                if (c == "intent") {
                    continue;
                }
                if (c == "email") {
                    continue;
                }
                if (c == "phone") {
                    continue;
                }
                if (c != "id") {
                    this.addProp1(c, a.item(c));
                }
            }
            if (a.id == null) {
                this.addProp1("id", "null");
            }
            else {
                this.addProp("id");
                this.addObjectOpen();
                let h = a.id.getKeys();
                for (let g = 0; g < h.length; g++) {
                    let f = h[g];
                    this.addProp1(f, a.id.item(f));
                }
                this.addObjectClose();
            }
            this.addObjectClose(b);
        }
        add7(a) {
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let d = a.getKeys();
            for (let c = 0; c < d.length; c++) {
                let b = d[c];
                if (b == "type") {
                    continue;
                }
                if (b == "name") {
                    continue;
                }
                if (b == "target") {
                    continue;
                }
                if (b == "intent") {
                    continue;
                }
                if (b == "id") {
                    continue;
                }
                if (b != "organizations") {
                    this.addProp1(b, a.item(b));
                }
            }
            if (a.organizations == null) {
                this.addProp1("organizations", "null");
            }
            else {
                this.addProp("organizations");
                this.addArrayOpen();
                let g = a.organizations;
                for (let f = 0; f < g.length; f++) {
                    let e = g[f];
                    this.add4(e, ",");
                }
                this.addArrayClose();
            }
            this.addObjectClose();
        }
        add3(a, b = "") {
            this.z("serializing Fdc3Context");
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let e = a.getKeys();
            for (let d = 0; d < e.length; d++) {
                let c = e[d];
                if (c == "type") {
                    continue;
                }
                if (c == "name") {
                    continue;
                }
                if (c == "target") {
                    continue;
                }
                if (c == "intent") {
                    continue;
                }
                if (c != "id") {
                    this.addProp1(c, a.item(c));
                }
            }
            if (a.id == null) {
                this.addProp1("id", "null");
            }
            else {
                this.addProp("id");
                this.addObjectOpen();
                let h = a.id.getKeys();
                for (let g = 0; g < h.length; g++) {
                    let f = h[g];
                    this.addProp1(f, a.id.item(f));
                }
                this.addObjectClose();
            }
            this.addObjectClose(b);
        }
        addArrayOpen() {
            this.addLine("[");
            this.tabIncrease();
            return this;
        }
        addArrayClose(a = "") {
            this.tabDecrease();
            this.addLine("]" + a);
            return this;
        }
        addObjectOpen() {
            this.addLine("{");
            this.tabIncrease();
            return this;
        }
        addObjectClose(a = "") {
            this.tabDecrease();
            this.addLine("}" + a);
            return this;
        }
        add(a) {
            this.i();
            this._sb.l(a);
            return this;
        }
        addLine(a) {
            this.i();
            this._sb.u(a);
            this.l = true;
            return this;
        }
        addProp(a) {
            this.i();
            this._sb.u("\"" + a + "\": ");
            this.l = true;
            return this;
        }
        addProp1(a, b, c = "") {
            this.i();
            if (!stringIsNullOrEmpty(c)) {
                c = " // " + c;
            }
            let d = b == null ? "null" : b;
            if (typeof b === 'string') {
                this._sb.u("\"" + a + "\": \"" + d + "\"," + c);
            }
            else if (typeCast(Boolean_$type, b) !== null) {
                let e = d.toString().toLowerCase();
                this._sb.u("\"" + a + "\": " + e + "," + c);
            }
            else {
                this._sb.u("\"" + a + "\": " + d + "," + c);
            }
            this.l = true;
            return this;
        }
        i() {
            if (this.l) {
                for (let a = 0; a < this.m; a++) {
                    this._sb.l("    ");
                }
                this.l = false;
            }
            return this;
        }
        tabIncrease() {
            this.m++;
            return this;
        }
        tabDecrease() {
            this.m--;
            return this;
        }
    }
    Fdc3Serializer.$t = /*@__PURE__*/ markType(Fdc3Serializer, 'Fdc3Serializer');
    return Fdc3Serializer;
})();
/**
 * @hidden
 */
let Fdc3Context = /*@__PURE__*/ (() => {
    class Fdc3Context extends Fdc3Dictionary {
        constructor(a, ..._rest) {
            super();
            this._id = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [0];
                        {
                            let e = c[0];
                            this.type = Fdc3Util.getString(e);
                            this.id = new Fdc3Dictionary();
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.type = Fdc3Util.getString(c);
                        this.id = new Fdc3Dictionary();
                    }
                    break;
            }
        }
        get intent() {
            return Fdc3Util.b(this.item("intent").toString());
        }
        set intent(a) {
            this.item("intent", enumGetBox(Fdc3IntentType_$type, a));
        }
        get type() {
            return this.item("type").toString();
        }
        set type(a) {
            this.item("type", a);
        }
        get target() {
            return this.h("target");
        }
        set target(a) {
            this.item("target", a);
        }
        get name() {
            return this.h("name");
        }
        set name(a) {
            this.item("name", a);
        }
        get id() {
            return this._id;
        }
        set id(a) {
            this._id = a;
        }
        toJson() {
            let a = new Fdc3Serializer();
            let b = a.toJson(this);
            return b;
        }
    }
    Fdc3Context.$t = /*@__PURE__*/ markType(Fdc3Context, 'Fdc3Context', Fdc3Dictionary.$);
    return Fdc3Context;
})();
/**
 * @hidden
 */
let Fdc3Instrument = /*@__PURE__*/ (() => {
    class Fdc3Instrument extends Fdc3Context {
        constructor() {
            super(1, 1);
        }
        get ticker() {
            return this.id.item("ticker").toString();
        }
        set ticker(a) {
            this.id.item("ticker", a);
        }
    }
    Fdc3Instrument.$t = /*@__PURE__*/ markType(Fdc3Instrument, 'Fdc3Instrument', Fdc3Context.$);
    return Fdc3Instrument;
})();
/**
 * @hidden
 */
let Fdc3InstrumentList = /*@__PURE__*/ (() => {
    class Fdc3InstrumentList extends Fdc3Context {
        constructor() {
            super(0);
            this._instruments = null;
            this.type = Fdc3Util.getString(2);
            this.instruments = new Array(0);
        }
        get instruments() {
            return this._instruments;
        }
        set instruments(a) {
            this._instruments = a;
        }
    }
    Fdc3InstrumentList.$t = /*@__PURE__*/ markType(Fdc3InstrumentList, 'Fdc3InstrumentList', Fdc3Context.$);
    return Fdc3InstrumentList;
})();
/**
 * @hidden
 */
let Fdc3Position = /*@__PURE__*/ (() => {
    class Fdc3Position extends Fdc3Context {
        constructor() {
            super(1, 3);
            this.instrument = new Fdc3Instrument();
        }
        get instrument() {
            return typeCast(Fdc3Instrument.$, this.item("instrument"));
        }
        set instrument(a) {
            this.item("instrument", a);
        }
        get shares() {
            return this.e("shares");
        }
        set shares(a) {
            this.item("shares", a);
        }
        get cost() {
            return this.e("cost");
        }
        set cost(a) {
            this.item("cost", a);
        }
        get price() {
            return this.e("price");
        }
        set price(a) {
            this.item("price", a);
        }
    }
    Fdc3Position.$t = /*@__PURE__*/ markType(Fdc3Position, 'Fdc3Position', Fdc3Context.$);
    return Fdc3Position;
})();
/**
 * @hidden
 */
let Fdc3Portfolio = /*@__PURE__*/ (() => {
    class Fdc3Portfolio extends Fdc3Context {
        constructor() {
            super(1, 4);
            this._positions = null;
            this.positions = new Array(0);
        }
        get positions() {
            return this._positions;
        }
        set positions(a) {
            this._positions = a;
        }
    }
    Fdc3Portfolio.$t = /*@__PURE__*/ markType(Fdc3Portfolio, 'Fdc3Portfolio', Fdc3Context.$);
    return Fdc3Portfolio;
})();
/**
 * @hidden
 */
let Fdc3Organization = /*@__PURE__*/ (() => {
    class Fdc3Organization extends Fdc3Context {
        constructor() {
            super(1, 7);
        }
    }
    Fdc3Organization.$t = /*@__PURE__*/ markType(Fdc3Organization, 'Fdc3Organization', Fdc3Context.$);
    return Fdc3Organization;
})();
/**
 * @hidden
 */
let Fdc3OrganizationList = /*@__PURE__*/ (() => {
    class Fdc3OrganizationList extends Fdc3Context {
        constructor() {
            super(1, 8);
            this._organizations = null;
        }
        get organizations() {
            return this._organizations;
        }
        set organizations(a) {
            this._organizations = a;
        }
    }
    Fdc3OrganizationList.$t = /*@__PURE__*/ markType(Fdc3OrganizationList, 'Fdc3OrganizationList', Fdc3Context.$);
    return Fdc3OrganizationList;
})();
/**
 * @hidden
 */
let Fdc3Contact = /*@__PURE__*/ (() => {
    class Fdc3Contact extends Fdc3Context {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = ["", "", "", ""];
                        {
                            let e = c[0];
                            let f = c[1];
                            let g = c[2];
                            let h = c[3];
                            super(1, 5);
                            this.name = e;
                            this.email = f;
                            this.phone = g;
                            this.twitter = h;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        super(1, 5);
                        this.name = c;
                        this.email = d;
                        this.phone = e;
                        this.twitter = f;
                    }
                    break;
            }
        }
        get email() {
            return this.id.item("email").toString();
        }
        set email(a) {
            this.id.item("email", a);
        }
        get phone() {
            return this.id.item("phone").toString();
        }
        set phone(a) {
            this.id.item("phone", a);
        }
        get twitter() {
            return this.id.item("twitter").toString();
        }
        set twitter(a) {
            this.id.item("twitter", a);
        }
    }
    Fdc3Contact.$t = /*@__PURE__*/ markType(Fdc3Contact, 'Fdc3Contact', Fdc3Context.$);
    return Fdc3Contact;
})();
/**
 * @hidden
 */
let Fdc3ContactList = /*@__PURE__*/ (() => {
    class Fdc3ContactList extends Fdc3Context {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, 6);
                        this._contacts = null;
                        this.contacts = new Array(0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        {
                            super(1, 6);
                            this._contacts = null;
                            this.contacts = new Array(0);
                        }
                        this.contacts = c;
                    }
                    break;
            }
        }
        get contacts() {
            return this._contacts;
        }
        set contacts(a) {
            this._contacts = a;
        }
    }
    Fdc3ContactList.$t = /*@__PURE__*/ markType(Fdc3ContactList, 'Fdc3ContactList', Fdc3Context.$);
    return Fdc3ContactList;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Fdc3Converter = /*@__PURE__*/ (() => {
    class Fdc3Converter extends Base {
        static log(message_) {
        }
        static toInstrument(context_) {
            let instrument_ = new Fdc3Instrument();
            if (context_ == null) {
                return instrument_;
            }
            // Fdc3Converter.log('converting to Instrument');
            var propNames = Object.getOwnPropertyNames(context_);
            for (var i = 0; i < propNames.length; i++) {
                var prop = propNames[i];
                if (prop === 'id') {
                    var propIDs = Object.getOwnPropertyNames(context_[prop]);
                    for (var ii = 0; ii < propIDs.length; ii++) {
                        var id = propIDs[ii];
                        instrument_.id.set(id, context_[prop][id]);
                    }
                }
                else {
                    instrument_.set(prop, context_[prop]);
                }
            }
            ;
            return instrument_;
        }
        static toInstrumentList(context_) {
            let list_ = new Fdc3InstrumentList();
            if (context_ == null) {
                return list_;
            }
            // Fdc3Converter.log('converting to InstrumentList'); 
            var propNames = Object.getOwnPropertyNames(context_);
            for (var i = 0; i < propNames.length; i++) {
                var prop = propNames[i];
                if (context_[prop] instanceof Array) {
                    var array = context_[prop];
                    for (var ii = 0; ii < array.length; ii++) {
                        var item = array[ii];
                        if (item['type'] === 'fdc3.instrument') {
                            var instrument = this.toInstrument(item);
                            list_.instruments.push(instrument);
                        }
                    }
                }
                else {
                    list_.set(prop, context_[prop]);
                }
            }
            ;
            return list_;
        }
        static toPosition(context_) {
            let position_ = new Fdc3Position();
            if (context_ == null) {
                return position_;
            }
            // Fdc3Converter.log('converting to Position');
            var propNames = Object.getOwnPropertyNames(context_);
            for (var i = 0; i < propNames.length; i++) {
                var prop = propNames[i];
                if (prop === 'instrument') {
                    var inst = Fdc3Converter.toInstrument(context_[prop]);
                    position_.instrument = inst;
                }
                else {
                    position_.set(prop, context_[prop]);
                }
            }
            ;
            return position_;
        }
        static toPortfolio(context_) {
            let portfolio_ = new Fdc3Portfolio();
            if (context_ == null) {
                return portfolio_;
            }
            // Fdc3Converter.log('converting to Portfolio'); 
            var propNames = Object.getOwnPropertyNames(context_);
            for (var i = 0; i < propNames.length; i++) {
                var prop = propNames[i];
                if (context_[prop] instanceof Array) {
                    // Fdc3Converter.log('array ');
                    var array = context_[prop];
                    for (var ii = 0; ii < array.length; ii++) {
                        var item = array[ii];
                        if (item['type'] === 'fdc3.position') {
                            var position_ = Fdc3Converter.toPosition(item);
                            portfolio_.positions.push(position_);
                        }
                    }
                }
                else {
                    portfolio_.set(prop, context_[prop]);
                }
            }
            ;
            return portfolio_;
        }
        static fromPortfolio(portfolio_) {
            let context_ = null;
            if (portfolio_ == null) {
                return context_;
            }
            // Fdc3Converter.log('converting from Portfolio'); 
            context_ = {};
            var propNames = portfolio_.getKeys();
            for (var i = 0; i < propNames.length; i++) {
                var prop = propNames[i];
                context_[prop] = portfolio_.item(prop);
            }
            context_.positions = [];
            for (var i = 0; i < portfolio_.positions.length; i++) {
                var position_ = portfolio_.positions[i];
                var item = Fdc3Converter.fromPosition(position_);
                context_.positions.push(item);
            }
            ;
            return context_;
        }
        static fromPosition(position_) {
            let context_ = null;
            if (position_ == null) {
                return context_;
            }
            // Fdc3Converter.log('converting from position');  
            context_ = {};
            var propNames = position_.getKeys();
            for (var i = 0; i < propNames.length; i++) {
                var prop = propNames[i];
                context_[prop] = position_.item(prop);
            }
            context_.instrument = Fdc3Converter.fromInstrument(position_.instrument);
            ;
            return context_;
        }
        static fromInstrumentList(list_) {
            let context_ = null;
            if (list_ == null) {
                return context_;
            }
            // Fdc3Converter.log('converting from InstrumentList');   
            context_ = {};
            var propNames = list_.getKeys();
            for (var i = 0; i < propNames.length; i++) {
                var prop = propNames[i];
                context_[prop] = list_.item(prop);
            }
            context_.instruments = [];
            for (var i = 0; i < list_.instruments.length; i++) {
                var instrument = list_.instruments[i];
                var item = Fdc3Converter.fromInstrument(instrument);
                context_.instruments.push(item);
            }
            ;
            return context_;
        }
        static fromInstrument(instrument_) {
            let context_ = null;
            if (instrument_ == null) {
                return context_;
            }
            // Fdc3Converter.log('converting from Instrument');    
            context_ = {};
            var propNames = instrument_.getKeys();
            for (var i = 0; i < propNames.length; i++) {
                var prop = propNames[i];
                context_[prop] = instrument_.item(prop);
            }
            context_.id = {};
            var propIDs = instrument_.id.getKeys();
            for (var i = 0; i < propIDs.length; i++) {
                var prop = propIDs[i];
                context_.id[prop] = instrument_.id.item(prop);
            }
            ;
            return context_;
        }
    }
    Fdc3Converter.$t = /*@__PURE__*/ markType(Fdc3Converter, 'Fdc3Converter');
    return Fdc3Converter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Fdc3Message = /*@__PURE__*/ (() => {
    class Fdc3Message extends Base {
        constructor() {
            super();
            this._tickerSymbols = null;
            this._tickerNames = null;
            this._json = null;
            this._context = null;
            this._intentType = null;
            this._contextType = null;
            this.tickerNames = new Array(0);
            this.tickerSymbols = new Array(0);
        }
        get tickerSymbols() {
            return this._tickerSymbols;
        }
        set tickerSymbols(a) {
            this._tickerSymbols = a;
        }
        get tickerNames() {
            return this._tickerNames;
        }
        set tickerNames(a) {
            this._tickerNames = a;
        }
        get json() {
            return this._json;
        }
        set json(a) {
            this._json = a;
        }
        get context() {
            return this._context;
        }
        set context(a) {
            this._context = a;
        }
        get intentType() {
            return this._intentType;
        }
        set intentType(a) {
            this._intentType = a;
        }
        get contextType() {
            return this._contextType;
        }
        set contextType(a) {
            this._contextType = a;
        }
    }
    Fdc3Message.$t = /*@__PURE__*/ markType(Fdc3Message, 'Fdc3Message');
    return Fdc3Message;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Fdc3DataAdapter = /*@__PURE__*/ (() => {
    class Fdc3DataAdapter extends FinancialDataAdapter {
        aq(a, b, c) {
            super.aq(a, b, c);
        }
        ba(a) {
            if (a == null) {
                return;
            }
            if (a.context != null && stringIsNullOrEmpty(a.json)) {
                a.json = a.context.toJson();
                this.log("received '" + a.intentType + "' intent '" + a.contextType + "' context with JSON:\n" + a.json);
            }
            if (this.messageReceived != null && a != null) {
                this.messageReceived(a);
            }
        }
        a5() {
            let isRunning_ = true;
            if (!window.hasOwnProperty('fin')) {
                isRunning_ = false;
            }
            ;
            return isRunning_;
        }
        subscribe(intentType_, contextType_ = "") {
            if (!this.a5()) {
                return;
            }
            if (stringIsNullOrEmpty(intentType_)) {
                intentType_ = "ViewChart";
            }
            this.log("Subscribing to '" + intentType_ + "' intent and '" + contextType_ + "' context");
            let addIntentListener_ = this._openFin.addIntentListener;
            // calling OpenFin API:
            addIntentListener_(intentType_, (context) => {
                return new Promise((resolve, reject) => {
                    try {
                        this.log('Subscriber received context ');
                        if (context.type == null || context.type === undefined) {
                            this.log('Subscriber received context with missing context.type');
                            return;
                        }
                        if (contextType_ !== '' && contextType_ !== context.type) {
                            this.log('Subscriber skipping not matching context.type');
                            return;
                        }
                        // call function to handle intent and process its context
                        this.handleIntent(context, context.type, intentType_);
                        resolve();
                    }
                    catch (e) {
                        this.log('Subscriber detected error with ' + intentType_ + ' intent: \n' + e);
                        reject(e);
                    }
                });
            });
            ;
        }
        handleIntent(context_, contextType_, intentType_) {
            let msg_ = new Fdc3Message();
            this.log("HandleIntent '" + intentType_ + "' intent with '" + contextType_ + "' context");
            msg_.intentType = intentType_;
            msg_.contextType = contextType_;
            this.log('HandleIntent');
            if (contextType_ === 'fdc3.instrument') {
                var instrument = Fdc3Converter.toInstrument(context_);
                msg_.context = instrument;
            }
            else if (contextType_ === 'fdc3.instrumentList') {
                var list = Fdc3Converter.toInstrumentList(context_);
                msg_.context = list;
            }
            else if (contextType_ === 'fdc3.position') {
                var position = Fdc3Converter.toPosition(context_);
                msg_.context = position;
            }
            else if (contextType_ === 'fdc3.portfolio') {
                var portfolio = Fdc3Converter.toPortfolio(context_);
                msg_.context = portfolio;
            }
            else // TODO other unsupported/custom context of FDC3 messages
             {
                //  var custom = Fdc3Converter.toPortfolio(context_);
                //  msg_.context = custom;
                //  this.log('received custom \n' + custom.toJson());
            }
            ;
            let a = new List$1(Fdc3Position.$, 0);
            let b = new List$1(Fdc3Instrument.$, 0);
            let c = new List$1(String_$type, 0);
            let d = new List$1(String_$type, 0);
            if (contextType_ == "fdc3.instrument") {
                this.v.clear();
                arrayClear(this.stockPrices);
                let e = typeCast(Fdc3Instrument.$, msg_.context);
                b.add(e);
                let f = e.ticker;
                if (!c.contains(f)) {
                    c.add(f);
                }
                let g = e.name;
                if (!d.contains(g)) {
                    d.add(g);
                }
            }
            else if (contextType_ == "fdc3.instrumentList") {
                this.v.clear();
                arrayClear(this.stockPrices);
                let h = typeCast(Fdc3InstrumentList.$, msg_.context);
                b.o(h.instruments);
                let k = h.instruments;
                for (let j = 0; j < k.length; j++) {
                    let i = k[j];
                    let l = i.ticker;
                    if (!c.contains(l)) {
                        c.add(l);
                    }
                    let m = i.name;
                    if (!d.contains(m)) {
                        d.add(m);
                    }
                }
            }
            else if (contextType_ == "fdc3.position") {
                let n = typeCast(Fdc3Position.$, msg_.context);
                a.add(n);
                let o = n.instrument.ticker;
                if (!c.contains(o)) {
                    c.add(n.instrument.ticker);
                }
                let p = n.instrument.name;
                if (!d.contains(p)) {
                    d.add(p);
                }
            }
            else if (contextType_ == "fdc3.portfolio") {
                this.x.clear();
                arrayClear(this.stockPositions);
                let q = typeCast(Fdc3Portfolio.$, msg_.context);
                a.o(q.positions);
                let t = q.positions;
                for (let s = 0; s < t.length; s++) {
                    let r = t[s];
                    let u = r.instrument.ticker;
                    if (!c.contains(u)) {
                        c.add(r.instrument.ticker);
                    }
                    let v = r.instrument.name;
                    if (!d.contains(v)) {
                        d.add(v);
                    }
                }
            }
            msg_.tickerSymbols = this.f(String_$type, c);
            msg_.tickerNames = this.f(String_$type, d);
            this.log("HandleIntent tickerSymbols " + msg_.tickerSymbols);
            this.log("HandleIntent instrumentList " + b.count);
            this.log("HandleIntent positionList " + a.count);
            for (let w of fromEnum(b)) {
                let x = w.ticker;
                if (stringIsNullOrEmpty(x)) {
                    continue;
                }
                let y = this.q(x);
                this.ao(x, y);
            }
            for (let z of fromEnum(a)) {
                let aa = z.instrument.ticker;
                if (stringIsNullOrEmpty(aa)) {
                    continue;
                }
                let ab = this.p(aa);
                if (z.cost > 0) {
                    ab.costPerShare = z.cost;
                }
                if (z.shares > 0) {
                    ab.shares = z.shares;
                }
                if (z.price > 0) {
                    ab.marketPrice = z.price;
                }
                this.an(aa, ab);
            }
            this.ba(msg_);
        }
        sendInstrument(a, b, c = "") {
            if (b == null) {
                return;
            }
            let d = Fdc3Converter.fromInstrument(b);
            this.bb(a, d, c);
        }
        sendInstrumentList(a, b, c = "") {
            if (b == null) {
                return;
            }
            let d = Fdc3Converter.fromInstrumentList(b);
            this.bb(a, d, c);
        }
        sendPosition(a, b, c = "") {
            if (b == null) {
                return;
            }
            let d = Fdc3Converter.fromPosition(b);
            this.bb(a, d, c);
        }
        sendPortfolio(a, b, c = "") {
            if (b == null) {
                return;
            }
            let d = Fdc3Converter.fromPortfolio(b);
            this.bb(a, d, c);
        }
        bb(intent_, context_, target_ = "") {
            if (!this.a5()) {
                return;
            }
            let raiseIntent_ = this._openFin.raiseIntent;
            this.log('Sending \'' + intent_ + '\' intent to \'' + target_ + '\' target');
            // calling OpenFin API: 
            if (target_ == null || target_ === '') {
                raiseIntent_(intent_, context_); // send to all OpenFin apps
            }
            else {
                raiseIntent_(intent_, context_, target_); // send only to Target app
            }
            ;
        }
        constructor(a) {
            super();
            this.messageReceived = null;
            this._openFin = null;
            this.a3 = false;
            this._openFin = a;
        }
        get a4() {
            return this.a3;
        }
        set a4(a) {
            this.a3 = a;
        }
        a7(a) {
            this.a4 = true;
        }
        dispose() {
            this.a7(true);
        }
    }
    Fdc3DataAdapter.$t = /*@__PURE__*/ markType(Fdc3DataAdapter, 'Fdc3DataAdapter', FinancialDataAdapter.$, [IDisposable_$type]);
    return Fdc3DataAdapter;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Randomizer = /*@__PURE__*/ (() => {
    class Randomizer extends Base {
        static d(a) {
            let b = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
            let c = "";
            for (let d = 0; d < a; d++) {
                let e = Randomizer.c.next1(b.length);
                c += b.charAt(e);
            }
            return c;
        }
        static b(a, b) {
            return Randomizer.c.next2(a, b);
        }
        static a(a) {
            let b = Math.pow(10, (a - 1));
            let c = 9 * b;
            return Randomizer.c.next2(truncate(b), truncate(c));
        }
    }
    Randomizer.$t = /*@__PURE__*/ markType(Randomizer, 'Randomizer');
    Randomizer.c = /*@__PURE__*/ new Random(0);
    return Randomizer;
})();

export { Fdc3Contact, Fdc3ContactList, Fdc3Context, Fdc3ContextType, Fdc3ContextType_$type, Fdc3Converter, Fdc3DataAdapter, Fdc3Dictionary, Fdc3Instrument, Fdc3InstrumentList, Fdc3IntentType, Fdc3IntentType_$type, Fdc3Message, Fdc3Organization, Fdc3OrganizationList, Fdc3Portfolio, Fdc3Position, Fdc3Serializer, Fdc3Util, Randomizer };
