import { FinancialDataAdapter } from "igniteui-webcomponents-core";
import { IDisposable, Type } from "igniteui-webcomponents-core";
import { Fdc3Message } from "./Fdc3Message";
import { Fdc3Position } from "./Fdc3Position";
import { Fdc3Instrument } from "./Fdc3Instrument";
import { Fdc3InstrumentList } from "./Fdc3InstrumentList";
import { Fdc3Portfolio } from "./Fdc3Portfolio";
/**
 * @hidden
 */
export declare class Fdc3DataAdapter extends FinancialDataAdapter implements IDisposable {
    static $t: Type;
    protected aq(a: string, b: any, c: any): void;
    messageReceived: (message: Fdc3Message) => void;
    ba(a: Fdc3Message): void;
    a5(): boolean;
    subscribe(intentType_: string, contextType_?: string): void;
    private handleIntent;
    sendInstrument(a: string, b: Fdc3Instrument, c?: string): void;
    sendInstrumentList(a: string, b: Fdc3InstrumentList, c?: string): void;
    sendPosition(a: string, b: Fdc3Position, c?: string): void;
    sendPortfolio(a: string, b: Fdc3Portfolio, c?: string): void;
    private bb;
    private _openFin;
    constructor(a: any);
    private a3;
    private get a4();
    private set a4(value);
    protected a7(a: boolean): void;
    dispose(): void;
}
