/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, EnumUtil, Boolean_$type, markType, enumGetBox } from "igniteui-webcomponents-core";
import { StringBuilder } from "igniteui-webcomponents-core";
import { Fdc3IntentType_$type } from "./Fdc3IntentType";
import { Fdc3Dictionary } from "./Fdc3Dictionary";
import { stringIsNullOrEmpty } from "igniteui-webcomponents-core";
import { Fdc3Util } from "./Fdc3Util";
/**
 * @hidden
 */
export let Fdc3Serializer = /*@__PURE__*/ (() => {
    class Fdc3Serializer extends Base {
        constructor() {
            super();
            this._sb = null;
            this.m = 0;
            this.l = false;
            this._sb = new StringBuilder(0);
        }
        toString() {
            return this._sb.toString();
        }
        toJson(a) {
            this._sb.v();
            if (typeCast(Fdc3Instrument.$, a) !== null) {
                this.add4(typeCast(Fdc3Instrument.$, a));
            }
            else if (typeCast(Fdc3InstrumentList.$, a) !== null) {
                this.add5(typeCast(Fdc3InstrumentList.$, a));
            }
            else if (typeCast(Fdc3Position.$, a) !== null) {
                this.add9(typeCast(Fdc3Position.$, a));
            }
            else if (typeCast(Fdc3Portfolio.$, a) !== null) {
                this.add8(typeCast(Fdc3Portfolio.$, a));
            }
            else if (typeCast(Fdc3Contact.$, a) !== null) {
                this.add1(typeCast(Fdc3Contact.$, a));
            }
            else if (typeCast(Fdc3ContactList.$, a) !== null) {
                this.add2(typeCast(Fdc3ContactList.$, a));
            }
            else if (typeCast(Fdc3Organization.$, a) !== null) {
                this.add6(typeCast(Fdc3Organization.$, a));
            }
            else if (typeCast(Fdc3OrganizationList.$, a) !== null) {
                this.add7(typeCast(Fdc3OrganizationList.$, a));
            }
            else {
                this.add3(typeCast(Fdc3Context.$, a));
            }
            return this.toString();
        }
        add4(a, b = "") {
            this.z("serializing Fdc3Instrument");
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let e = a.getKeys();
            for (let d = 0; d < e.length; d++) {
                let c = e[d];
                if (c == "type") {
                    continue;
                }
                if (c == "name") {
                    continue;
                }
                if (c == "target") {
                    continue;
                }
                if (c == "intent") {
                    continue;
                }
                if (c == "ticker") {
                    continue;
                }
                if (c != "id") {
                    this.addProp1(c, a.item(c));
                }
            }
            if (a.id == null) {
                this.addProp1("id", "null");
            }
            else {
                this.addProp("id");
                this.addObjectOpen();
                this.addProp1("ticker", a.ticker);
                let h = a.id.getKeys();
                for (let g = 0; g < h.length; g++) {
                    let f = h[g];
                    if (f == "ticker") {
                        continue;
                    }
                    this.addProp1(f, a.id.item(f));
                }
                this.addObjectClose();
            }
            this.addObjectClose(b);
        }
        add5(a) {
            this.z("serializing Fdc3InstrumentList");
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let d = a.getKeys();
            for (let c = 0; c < d.length; c++) {
                let b = d[c];
                if (b == "type") {
                    continue;
                }
                if (b == "name") {
                    continue;
                }
                if (b == "target") {
                    continue;
                }
                if (b == "intent") {
                    continue;
                }
                if (b == "id") {
                    continue;
                }
                if (b != "instruments") {
                    this.addProp1(b, a.item(b));
                }
            }
            if (a.instruments == null) {
                this.addProp1("instruments", "null");
            }
            else {
                this.addProp("instruments");
                this.addArrayOpen();
                let g = a.instruments;
                for (let f = 0; f < g.length; f++) {
                    let e = g[f];
                    this.add4(e, ",");
                }
                this.addArrayClose();
            }
            this.addObjectClose();
        }
        add8(a) {
            this.z("serializing Fdc3Portfolio");
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let d = a.getKeys();
            for (let c = 0; c < d.length; c++) {
                let b = d[c];
                if (b == "type") {
                    continue;
                }
                if (b == "name") {
                    continue;
                }
                if (b == "target") {
                    continue;
                }
                if (b == "intent") {
                    continue;
                }
                if (b == "id") {
                    continue;
                }
                if (b != "positions") {
                    this.addProp1(b, a.item(b));
                }
            }
            if (a.positions == null) {
                this.addProp1("positions", "null");
            }
            else {
                this.addProp("positions");
                this.addArrayOpen();
                let g = a.positions;
                for (let f = 0; f < g.length; f++) {
                    let e = g[f];
                    this.add9(e, ",");
                }
                this.addArrayClose();
            }
            this.addObjectClose();
        }
        add9(a, b = "") {
            this.z("serializing Fdc3Position");
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let e = a.getKeys();
            for (let d = 0; d < e.length; d++) {
                let c = e[d];
                if (c == "type") {
                    continue;
                }
                if (c == "name") {
                    continue;
                }
                if (c == "target") {
                    continue;
                }
                if (c == "intent") {
                    continue;
                }
                if (c == "id") {
                    continue;
                }
                if (c != "instrument") {
                    this.addProp1(c, a.item(c));
                }
            }
            if (a.instrument == null) {
                this.addProp1("instrument", "null");
            }
            else {
                this.addProp("instrument");
                this.add4(a.instrument, ",");
            }
            this.addObjectClose(b);
        }
        add1(a, b = "") {
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let e = a.getKeys();
            for (let d = 0; d < e.length; d++) {
                let c = e[d];
                if (c == "type") {
                    continue;
                }
                if (c == "name") {
                    continue;
                }
                if (c == "target") {
                    continue;
                }
                if (c == "intent") {
                    continue;
                }
                if (c == "email") {
                    continue;
                }
                if (c == "phone") {
                    continue;
                }
                if (c != "id") {
                    this.addProp1(c, a.item(c));
                }
            }
            if (a.id == null) {
                this.addProp1("id", "null");
            }
            else {
                this.addProp("id");
                this.addObjectOpen();
                let h = a.id.getKeys();
                for (let g = 0; g < h.length; g++) {
                    let f = h[g];
                    this.addProp1(f, a.id.item(f));
                }
                this.addObjectClose();
            }
            this.addObjectClose(b);
        }
        z(message_) {
        }
        add2(a) {
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let d = a.getKeys();
            for (let c = 0; c < d.length; c++) {
                let b = d[c];
                if (b == "type") {
                    continue;
                }
                if (b == "name") {
                    continue;
                }
                if (b == "target") {
                    continue;
                }
                if (b == "intent") {
                    continue;
                }
                if (b == "id") {
                    continue;
                }
                if (b != "contacts") {
                    this.addProp1(b, a.item(b));
                }
            }
            if (a.contacts == null) {
                this.addProp1("contacts", "null");
            }
            else {
                this.addProp("contacts");
                this.addArrayOpen();
                let g = a.contacts;
                for (let f = 0; f < g.length; f++) {
                    let e = g[f];
                    this.add1(e, ",");
                }
                this.addArrayClose();
            }
            this.addObjectClose();
        }
        add6(a, b = "") {
            this.z("serializing Fdc3Organization");
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let e = a.getKeys();
            for (let d = 0; d < e.length; d++) {
                let c = e[d];
                if (c == "type") {
                    continue;
                }
                if (c == "name") {
                    continue;
                }
                if (c == "target") {
                    continue;
                }
                if (c == "intent") {
                    continue;
                }
                if (c == "email") {
                    continue;
                }
                if (c == "phone") {
                    continue;
                }
                if (c != "id") {
                    this.addProp1(c, a.item(c));
                }
            }
            if (a.id == null) {
                this.addProp1("id", "null");
            }
            else {
                this.addProp("id");
                this.addObjectOpen();
                let h = a.id.getKeys();
                for (let g = 0; g < h.length; g++) {
                    let f = h[g];
                    this.addProp1(f, a.id.item(f));
                }
                this.addObjectClose();
            }
            this.addObjectClose(b);
        }
        add7(a) {
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let d = a.getKeys();
            for (let c = 0; c < d.length; c++) {
                let b = d[c];
                if (b == "type") {
                    continue;
                }
                if (b == "name") {
                    continue;
                }
                if (b == "target") {
                    continue;
                }
                if (b == "intent") {
                    continue;
                }
                if (b == "id") {
                    continue;
                }
                if (b != "organizations") {
                    this.addProp1(b, a.item(b));
                }
            }
            if (a.organizations == null) {
                this.addProp1("organizations", "null");
            }
            else {
                this.addProp("organizations");
                this.addArrayOpen();
                let g = a.organizations;
                for (let f = 0; f < g.length; f++) {
                    let e = g[f];
                    this.add4(e, ",");
                }
                this.addArrayClose();
            }
            this.addObjectClose();
        }
        add3(a, b = "") {
            this.z("serializing Fdc3Context");
            this.addObjectOpen();
            this.addProp1("type", a.type);
            if (!stringIsNullOrEmpty(a.target)) {
                this.addProp1("target", a.target);
            }
            if (a.intent != 2) {
                this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
            }
            if (!stringIsNullOrEmpty(a.name)) {
                this.addProp1("name", a.name);
            }
            let e = a.getKeys();
            for (let d = 0; d < e.length; d++) {
                let c = e[d];
                if (c == "type") {
                    continue;
                }
                if (c == "name") {
                    continue;
                }
                if (c == "target") {
                    continue;
                }
                if (c == "intent") {
                    continue;
                }
                if (c != "id") {
                    this.addProp1(c, a.item(c));
                }
            }
            if (a.id == null) {
                this.addProp1("id", "null");
            }
            else {
                this.addProp("id");
                this.addObjectOpen();
                let h = a.id.getKeys();
                for (let g = 0; g < h.length; g++) {
                    let f = h[g];
                    this.addProp1(f, a.id.item(f));
                }
                this.addObjectClose();
            }
            this.addObjectClose(b);
        }
        addArrayOpen() {
            this.addLine("[");
            this.tabIncrease();
            return this;
        }
        addArrayClose(a = "") {
            this.tabDecrease();
            this.addLine("]" + a);
            return this;
        }
        addObjectOpen() {
            this.addLine("{");
            this.tabIncrease();
            return this;
        }
        addObjectClose(a = "") {
            this.tabDecrease();
            this.addLine("}" + a);
            return this;
        }
        add(a) {
            this.i();
            this._sb.l(a);
            return this;
        }
        addLine(a) {
            this.i();
            this._sb.u(a);
            this.l = true;
            return this;
        }
        addProp(a) {
            this.i();
            this._sb.u("\"" + a + "\": ");
            this.l = true;
            return this;
        }
        addProp1(a, b, c = "") {
            this.i();
            if (!stringIsNullOrEmpty(c)) {
                c = " // " + c;
            }
            let d = b == null ? "null" : b;
            if (typeof b === 'string') {
                this._sb.u("\"" + a + "\": \"" + d + "\"," + c);
            }
            else if (typeCast(Boolean_$type, b) !== null) {
                let e = d.toString().toLowerCase();
                this._sb.u("\"" + a + "\": " + e + "," + c);
            }
            else {
                this._sb.u("\"" + a + "\": " + d + "," + c);
            }
            this.l = true;
            return this;
        }
        i() {
            if (this.l) {
                for (let a = 0; a < this.m; a++) {
                    this._sb.l("    ");
                }
                this.l = false;
            }
            return this;
        }
        tabIncrease() {
            this.m++;
            return this;
        }
        tabDecrease() {
            this.m--;
            return this;
        }
    }
    Fdc3Serializer.$t = /*@__PURE__*/ markType(Fdc3Serializer, 'Fdc3Serializer');
    return Fdc3Serializer;
})();
/**
 * @hidden
 */
export let Fdc3Context = /*@__PURE__*/ (() => {
    class Fdc3Context extends Fdc3Dictionary {
        constructor(a, ..._rest) {
            super();
            this._id = null;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = [0];
                        {
                            let e = c[0];
                            this.type = Fdc3Util.getString(e);
                            this.id = new Fdc3Dictionary();
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        this.type = Fdc3Util.getString(c);
                        this.id = new Fdc3Dictionary();
                    }
                    break;
            }
        }
        get intent() {
            return Fdc3Util.b(this.item("intent").toString());
        }
        set intent(a) {
            this.item("intent", enumGetBox(Fdc3IntentType_$type, a));
        }
        get type() {
            return this.item("type").toString();
        }
        set type(a) {
            this.item("type", a);
        }
        get target() {
            return this.h("target");
        }
        set target(a) {
            this.item("target", a);
        }
        get name() {
            return this.h("name");
        }
        set name(a) {
            this.item("name", a);
        }
        get id() {
            return this._id;
        }
        set id(a) {
            this._id = a;
        }
        toJson() {
            let a = new Fdc3Serializer();
            let b = a.toJson(this);
            return b;
        }
    }
    Fdc3Context.$t = /*@__PURE__*/ markType(Fdc3Context, 'Fdc3Context', Fdc3Dictionary.$);
    return Fdc3Context;
})();
/**
 * @hidden
 */
export let Fdc3Instrument = /*@__PURE__*/ (() => {
    class Fdc3Instrument extends Fdc3Context {
        constructor() {
            super(1, 1);
        }
        get ticker() {
            return this.id.item("ticker").toString();
        }
        set ticker(a) {
            this.id.item("ticker", a);
        }
    }
    Fdc3Instrument.$t = /*@__PURE__*/ markType(Fdc3Instrument, 'Fdc3Instrument', Fdc3Context.$);
    return Fdc3Instrument;
})();
/**
 * @hidden
 */
export let Fdc3InstrumentList = /*@__PURE__*/ (() => {
    class Fdc3InstrumentList extends Fdc3Context {
        constructor() {
            super(0);
            this._instruments = null;
            this.type = Fdc3Util.getString(2);
            this.instruments = new Array(0);
        }
        get instruments() {
            return this._instruments;
        }
        set instruments(a) {
            this._instruments = a;
        }
    }
    Fdc3InstrumentList.$t = /*@__PURE__*/ markType(Fdc3InstrumentList, 'Fdc3InstrumentList', Fdc3Context.$);
    return Fdc3InstrumentList;
})();
/**
 * @hidden
 */
export let Fdc3Position = /*@__PURE__*/ (() => {
    class Fdc3Position extends Fdc3Context {
        constructor() {
            super(1, 3);
            this.instrument = new Fdc3Instrument();
        }
        get instrument() {
            return typeCast(Fdc3Instrument.$, this.item("instrument"));
        }
        set instrument(a) {
            this.item("instrument", a);
        }
        get shares() {
            return this.e("shares");
        }
        set shares(a) {
            this.item("shares", a);
        }
        get cost() {
            return this.e("cost");
        }
        set cost(a) {
            this.item("cost", a);
        }
        get price() {
            return this.e("price");
        }
        set price(a) {
            this.item("price", a);
        }
    }
    Fdc3Position.$t = /*@__PURE__*/ markType(Fdc3Position, 'Fdc3Position', Fdc3Context.$);
    return Fdc3Position;
})();
/**
 * @hidden
 */
export let Fdc3Portfolio = /*@__PURE__*/ (() => {
    class Fdc3Portfolio extends Fdc3Context {
        constructor() {
            super(1, 4);
            this._positions = null;
            this.positions = new Array(0);
        }
        get positions() {
            return this._positions;
        }
        set positions(a) {
            this._positions = a;
        }
    }
    Fdc3Portfolio.$t = /*@__PURE__*/ markType(Fdc3Portfolio, 'Fdc3Portfolio', Fdc3Context.$);
    return Fdc3Portfolio;
})();
/**
 * @hidden
 */
export let Fdc3Organization = /*@__PURE__*/ (() => {
    class Fdc3Organization extends Fdc3Context {
        constructor() {
            super(1, 7);
        }
    }
    Fdc3Organization.$t = /*@__PURE__*/ markType(Fdc3Organization, 'Fdc3Organization', Fdc3Context.$);
    return Fdc3Organization;
})();
/**
 * @hidden
 */
export let Fdc3OrganizationList = /*@__PURE__*/ (() => {
    class Fdc3OrganizationList extends Fdc3Context {
        constructor() {
            super(1, 8);
            this._organizations = null;
        }
        get organizations() {
            return this._organizations;
        }
        set organizations(a) {
            this._organizations = a;
        }
    }
    Fdc3OrganizationList.$t = /*@__PURE__*/ markType(Fdc3OrganizationList, 'Fdc3OrganizationList', Fdc3Context.$);
    return Fdc3OrganizationList;
})();
/**
 * @hidden
 */
export let Fdc3Contact = /*@__PURE__*/ (() => {
    class Fdc3Contact extends Fdc3Context {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        let c = ["", "", "", ""];
                        {
                            let e = c[0];
                            let f = c[1];
                            let g = c[2];
                            let h = c[3];
                            super(1, 5);
                            this.name = e;
                            this.email = f;
                            this.phone = g;
                            this.twitter = h;
                        }
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        let d = _rest[1];
                        let e = _rest[2];
                        let f = _rest[3];
                        super(1, 5);
                        this.name = c;
                        this.email = d;
                        this.phone = e;
                        this.twitter = f;
                    }
                    break;
            }
        }
        get email() {
            return this.id.item("email").toString();
        }
        set email(a) {
            this.id.item("email", a);
        }
        get phone() {
            return this.id.item("phone").toString();
        }
        set phone(a) {
            this.id.item("phone", a);
        }
        get twitter() {
            return this.id.item("twitter").toString();
        }
        set twitter(a) {
            this.id.item("twitter", a);
        }
    }
    Fdc3Contact.$t = /*@__PURE__*/ markType(Fdc3Contact, 'Fdc3Contact', Fdc3Context.$);
    return Fdc3Contact;
})();
/**
 * @hidden
 */
export let Fdc3ContactList = /*@__PURE__*/ (() => {
    class Fdc3ContactList extends Fdc3Context {
        constructor(a, ..._rest) {
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0:
                    {
                        super(1, 6);
                        this._contacts = null;
                        this.contacts = new Array(0);
                    }
                    break;
                case 1:
                    {
                        let c = _rest[0];
                        {
                            super(1, 6);
                            this._contacts = null;
                            this.contacts = new Array(0);
                        }
                        this.contacts = c;
                    }
                    break;
            }
        }
        get contacts() {
            return this._contacts;
        }
        set contacts(a) {
            this._contacts = a;
        }
    }
    Fdc3ContactList.$t = /*@__PURE__*/ markType(Fdc3ContactList, 'Fdc3ContactList', Fdc3Context.$);
    return Fdc3ContactList;
})();
