/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, String_$type, fromEnum, markType } from "igniteui-webcomponents-core";
import { Dictionary$2 } from "igniteui-webcomponents-core";
import { List$1 } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var Fdc3Dictionary = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Dictionary, _super);
    function Fdc3Dictionary() {
        var _this = _super.call(this) || this;
        _this.d = null;
        _this.d = new Dictionary$2(String_$type, Base.$, 0);
        return _this;
    }
    Fdc3Dictionary.prototype.getKeys = function () {
        var e_1, _a;
        var a = new List$1(String_$type, 0);
        try {
            for (var _b = __values(fromEnum(this.d)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a.add(b.key);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return a.toArray();
    };
    Fdc3Dictionary.prototype.getValues = function () {
        var e_2, _a;
        var a = new List$1(Base.$, 0);
        try {
            for (var _b = __values(fromEnum(this.d)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a.add1(b.value);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return a.toArray();
    };
    Fdc3Dictionary.prototype.item = function (a, b) {
        if (arguments.length === 2) {
            this.set(a, b);
            return b;
        }
        else {
            return this.get(a);
        }
    };
    Fdc3Dictionary.prototype.get = function (a) {
        if (!this.d.containsKey(a)) {
            this.set(a, "");
        }
        if (this.d.item(a) == null) {
            return "";
        }
        return this.d.item(a);
    };
    Fdc3Dictionary.prototype.h = function (a) {
        return this.get(a).toString();
    };
    Fdc3Dictionary.prototype.e = function (a) {
        if (!this.d.containsKey(a)) {
            this.set(a, 0);
            return 0;
        }
        if (this.d.item(a) == null) {
            return 0;
        }
        return parseFloat(this.d.item(a).toString());
    };
    Fdc3Dictionary.prototype.set = function (a, b) {
        if (this.d.containsKey(a)) {
            this.d.item(a, b);
        }
        else {
            this.d.addItem(a, b);
        }
    };
    Fdc3Dictionary.prototype.remove = function (a) {
        if (this.d.containsKey(a)) {
            this.d.removeItem(a);
        }
    };
    Fdc3Dictionary.prototype.contains = function (a) {
        return this.d.containsKey(a);
    };
    Fdc3Dictionary.$t = markType(Fdc3Dictionary, 'Fdc3Dictionary');
    return Fdc3Dictionary;
}(Base));
export { Fdc3Dictionary };
