/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, typeCast, EnumUtil, Boolean_$type, markType, enumGetBox } from "igniteui-webcomponents-core";
import { StringBuilder } from "igniteui-webcomponents-core";
import { Fdc3IntentType_$type } from "./Fdc3IntentType";
import { Fdc3Dictionary } from "./Fdc3Dictionary";
import { stringIsNullOrEmpty } from "igniteui-webcomponents-core";
import { Fdc3Util } from "./Fdc3Util";
/**
 * @hidden
 */
var Fdc3Serializer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Serializer, _super);
    function Fdc3Serializer() {
        var _this = _super.call(this) || this;
        _this._sb = null;
        _this.m = 0;
        _this.l = false;
        _this._sb = new StringBuilder(0);
        return _this;
    }
    Fdc3Serializer.prototype.toString = function () {
        return this._sb.toString();
    };
    Fdc3Serializer.prototype.toJson = function (a) {
        this._sb.v();
        if (typeCast(Fdc3Instrument.$, a) !== null) {
            this.add4(typeCast(Fdc3Instrument.$, a));
        }
        else if (typeCast(Fdc3InstrumentList.$, a) !== null) {
            this.add5(typeCast(Fdc3InstrumentList.$, a));
        }
        else if (typeCast(Fdc3Position.$, a) !== null) {
            this.add9(typeCast(Fdc3Position.$, a));
        }
        else if (typeCast(Fdc3Portfolio.$, a) !== null) {
            this.add8(typeCast(Fdc3Portfolio.$, a));
        }
        else if (typeCast(Fdc3Contact.$, a) !== null) {
            this.add1(typeCast(Fdc3Contact.$, a));
        }
        else if (typeCast(Fdc3ContactList.$, a) !== null) {
            this.add2(typeCast(Fdc3ContactList.$, a));
        }
        else if (typeCast(Fdc3Organization.$, a) !== null) {
            this.add6(typeCast(Fdc3Organization.$, a));
        }
        else if (typeCast(Fdc3OrganizationList.$, a) !== null) {
            this.add7(typeCast(Fdc3OrganizationList.$, a));
        }
        else {
            this.add3(typeCast(Fdc3Context.$, a));
        }
        return this.toString();
    };
    Fdc3Serializer.prototype.add4 = function (a, b) {
        if (b === void 0) {
            b = "";
        }
        this.z("serializing Fdc3Instrument");
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var e = a.getKeys();
        for (var d = 0; d < e.length; d++) {
            var c = e[d];
            if (c == "type") {
                continue;
            }
            if (c == "name") {
                continue;
            }
            if (c == "target") {
                continue;
            }
            if (c == "intent") {
                continue;
            }
            if (c == "ticker") {
                continue;
            }
            if (c != "id") {
                this.addProp1(c, a.item(c));
            }
        }
        if (a.id == null) {
            this.addProp1("id", "null");
        }
        else {
            this.addProp("id");
            this.addObjectOpen();
            this.addProp1("ticker", a.ticker);
            var h = a.id.getKeys();
            for (var g = 0; g < h.length; g++) {
                var f = h[g];
                if (f == "ticker") {
                    continue;
                }
                this.addProp1(f, a.id.item(f));
            }
            this.addObjectClose();
        }
        this.addObjectClose(b);
    };
    Fdc3Serializer.prototype.add5 = function (a) {
        this.z("serializing Fdc3InstrumentList");
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var d = a.getKeys();
        for (var c = 0; c < d.length; c++) {
            var b = d[c];
            if (b == "type") {
                continue;
            }
            if (b == "name") {
                continue;
            }
            if (b == "target") {
                continue;
            }
            if (b == "intent") {
                continue;
            }
            if (b == "id") {
                continue;
            }
            if (b != "instruments") {
                this.addProp1(b, a.item(b));
            }
        }
        if (a.instruments == null) {
            this.addProp1("instruments", "null");
        }
        else {
            this.addProp("instruments");
            this.addArrayOpen();
            var g = a.instruments;
            for (var f = 0; f < g.length; f++) {
                var e = g[f];
                this.add4(e, ",");
            }
            this.addArrayClose();
        }
        this.addObjectClose();
    };
    Fdc3Serializer.prototype.add8 = function (a) {
        this.z("serializing Fdc3Portfolio");
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var d = a.getKeys();
        for (var c = 0; c < d.length; c++) {
            var b = d[c];
            if (b == "type") {
                continue;
            }
            if (b == "name") {
                continue;
            }
            if (b == "target") {
                continue;
            }
            if (b == "intent") {
                continue;
            }
            if (b == "id") {
                continue;
            }
            if (b != "positions") {
                this.addProp1(b, a.item(b));
            }
        }
        if (a.positions == null) {
            this.addProp1("positions", "null");
        }
        else {
            this.addProp("positions");
            this.addArrayOpen();
            var g = a.positions;
            for (var f = 0; f < g.length; f++) {
                var e = g[f];
                this.add9(e, ",");
            }
            this.addArrayClose();
        }
        this.addObjectClose();
    };
    Fdc3Serializer.prototype.add9 = function (a, b) {
        if (b === void 0) {
            b = "";
        }
        this.z("serializing Fdc3Position");
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var e = a.getKeys();
        for (var d = 0; d < e.length; d++) {
            var c = e[d];
            if (c == "type") {
                continue;
            }
            if (c == "name") {
                continue;
            }
            if (c == "target") {
                continue;
            }
            if (c == "intent") {
                continue;
            }
            if (c == "id") {
                continue;
            }
            if (c != "instrument") {
                this.addProp1(c, a.item(c));
            }
        }
        if (a.instrument == null) {
            this.addProp1("instrument", "null");
        }
        else {
            this.addProp("instrument");
            this.add4(a.instrument, ",");
        }
        this.addObjectClose(b);
    };
    Fdc3Serializer.prototype.add1 = function (a, b) {
        if (b === void 0) {
            b = "";
        }
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var e = a.getKeys();
        for (var d = 0; d < e.length; d++) {
            var c = e[d];
            if (c == "type") {
                continue;
            }
            if (c == "name") {
                continue;
            }
            if (c == "target") {
                continue;
            }
            if (c == "intent") {
                continue;
            }
            if (c == "email") {
                continue;
            }
            if (c == "phone") {
                continue;
            }
            if (c != "id") {
                this.addProp1(c, a.item(c));
            }
        }
        if (a.id == null) {
            this.addProp1("id", "null");
        }
        else {
            this.addProp("id");
            this.addObjectOpen();
            var h = a.id.getKeys();
            for (var g = 0; g < h.length; g++) {
                var f = h[g];
                this.addProp1(f, a.id.item(f));
            }
            this.addObjectClose();
        }
        this.addObjectClose(b);
    };
    Fdc3Serializer.prototype.z = function (message_) {
    };
    Fdc3Serializer.prototype.add2 = function (a) {
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var d = a.getKeys();
        for (var c = 0; c < d.length; c++) {
            var b = d[c];
            if (b == "type") {
                continue;
            }
            if (b == "name") {
                continue;
            }
            if (b == "target") {
                continue;
            }
            if (b == "intent") {
                continue;
            }
            if (b == "id") {
                continue;
            }
            if (b != "contacts") {
                this.addProp1(b, a.item(b));
            }
        }
        if (a.contacts == null) {
            this.addProp1("contacts", "null");
        }
        else {
            this.addProp("contacts");
            this.addArrayOpen();
            var g = a.contacts;
            for (var f = 0; f < g.length; f++) {
                var e = g[f];
                this.add1(e, ",");
            }
            this.addArrayClose();
        }
        this.addObjectClose();
    };
    Fdc3Serializer.prototype.add6 = function (a, b) {
        if (b === void 0) {
            b = "";
        }
        this.z("serializing Fdc3Organization");
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var e = a.getKeys();
        for (var d = 0; d < e.length; d++) {
            var c = e[d];
            if (c == "type") {
                continue;
            }
            if (c == "name") {
                continue;
            }
            if (c == "target") {
                continue;
            }
            if (c == "intent") {
                continue;
            }
            if (c == "email") {
                continue;
            }
            if (c == "phone") {
                continue;
            }
            if (c != "id") {
                this.addProp1(c, a.item(c));
            }
        }
        if (a.id == null) {
            this.addProp1("id", "null");
        }
        else {
            this.addProp("id");
            this.addObjectOpen();
            var h = a.id.getKeys();
            for (var g = 0; g < h.length; g++) {
                var f = h[g];
                this.addProp1(f, a.id.item(f));
            }
            this.addObjectClose();
        }
        this.addObjectClose(b);
    };
    Fdc3Serializer.prototype.add7 = function (a) {
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var d = a.getKeys();
        for (var c = 0; c < d.length; c++) {
            var b = d[c];
            if (b == "type") {
                continue;
            }
            if (b == "name") {
                continue;
            }
            if (b == "target") {
                continue;
            }
            if (b == "intent") {
                continue;
            }
            if (b == "id") {
                continue;
            }
            if (b != "organizations") {
                this.addProp1(b, a.item(b));
            }
        }
        if (a.organizations == null) {
            this.addProp1("organizations", "null");
        }
        else {
            this.addProp("organizations");
            this.addArrayOpen();
            var g = a.organizations;
            for (var f = 0; f < g.length; f++) {
                var e = g[f];
                this.add4(e, ",");
            }
            this.addArrayClose();
        }
        this.addObjectClose();
    };
    Fdc3Serializer.prototype.add3 = function (a, b) {
        if (b === void 0) {
            b = "";
        }
        this.z("serializing Fdc3Context");
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var e = a.getKeys();
        for (var d = 0; d < e.length; d++) {
            var c = e[d];
            if (c == "type") {
                continue;
            }
            if (c == "name") {
                continue;
            }
            if (c == "target") {
                continue;
            }
            if (c == "intent") {
                continue;
            }
            if (c != "id") {
                this.addProp1(c, a.item(c));
            }
        }
        if (a.id == null) {
            this.addProp1("id", "null");
        }
        else {
            this.addProp("id");
            this.addObjectOpen();
            var h = a.id.getKeys();
            for (var g = 0; g < h.length; g++) {
                var f = h[g];
                this.addProp1(f, a.id.item(f));
            }
            this.addObjectClose();
        }
        this.addObjectClose(b);
    };
    Fdc3Serializer.prototype.addArrayOpen = function () {
        this.addLine("[");
        this.tabIncrease();
        return this;
    };
    Fdc3Serializer.prototype.addArrayClose = function (a) {
        if (a === void 0) {
            a = "";
        }
        this.tabDecrease();
        this.addLine("]" + a);
        return this;
    };
    Fdc3Serializer.prototype.addObjectOpen = function () {
        this.addLine("{");
        this.tabIncrease();
        return this;
    };
    Fdc3Serializer.prototype.addObjectClose = function (a) {
        if (a === void 0) {
            a = "";
        }
        this.tabDecrease();
        this.addLine("}" + a);
        return this;
    };
    Fdc3Serializer.prototype.add = function (a) {
        this.i();
        this._sb.l(a);
        return this;
    };
    Fdc3Serializer.prototype.addLine = function (a) {
        this.i();
        this._sb.u(a);
        this.l = true;
        return this;
    };
    Fdc3Serializer.prototype.addProp = function (a) {
        this.i();
        this._sb.u("\"" + a + "\": ");
        this.l = true;
        return this;
    };
    Fdc3Serializer.prototype.addProp1 = function (a, b, c) {
        if (c === void 0) {
            c = "";
        }
        this.i();
        if (!stringIsNullOrEmpty(c)) {
            c = " // " + c;
        }
        var d = b == null ? "null" : b;
        if (typeof b === 'string') {
            this._sb.u("\"" + a + "\": \"" + d + "\"," + c);
        }
        else if (typeCast(Boolean_$type, b) !== null) {
            var e = d.toString().toLowerCase();
            this._sb.u("\"" + a + "\": " + e + "," + c);
        }
        else {
            this._sb.u("\"" + a + "\": " + d + "," + c);
        }
        this.l = true;
        return this;
    };
    Fdc3Serializer.prototype.i = function () {
        if (this.l) {
            for (var a = 0; a < this.m; a++) {
                this._sb.l("    ");
            }
            this.l = false;
        }
        return this;
    };
    Fdc3Serializer.prototype.tabIncrease = function () {
        this.m++;
        return this;
    };
    Fdc3Serializer.prototype.tabDecrease = function () {
        this.m--;
        return this;
    };
    Fdc3Serializer.$t = markType(Fdc3Serializer, 'Fdc3Serializer');
    return Fdc3Serializer;
}(Base));
export { Fdc3Serializer };
/**
 * @hidden
 */
var Fdc3Context = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Context, _super);
    function Fdc3Context(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this._id = null;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = [0];
                    {
                        var e = c[0];
                        _this.type = Fdc3Util.getString(e);
                        _this.id = new Fdc3Dictionary();
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    _this.type = Fdc3Util.getString(c);
                    _this.id = new Fdc3Dictionary();
                }
                break;
        }
        return _this;
    }
    Object.defineProperty(Fdc3Context.prototype, "intent", {
        get: function () {
            return Fdc3Util.b(this.item("intent").toString());
        },
        set: function (a) {
            this.item("intent", enumGetBox(Fdc3IntentType_$type, a));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Context.prototype, "type", {
        get: function () {
            return this.item("type").toString();
        },
        set: function (a) {
            this.item("type", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Context.prototype, "target", {
        get: function () {
            return this.h("target");
        },
        set: function (a) {
            this.item("target", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Context.prototype, "name", {
        get: function () {
            return this.h("name");
        },
        set: function (a) {
            this.item("name", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Context.prototype, "id", {
        get: function () {
            return this._id;
        },
        set: function (a) {
            this._id = a;
        },
        enumerable: false,
        configurable: true
    });
    Fdc3Context.prototype.toJson = function () {
        var a = new Fdc3Serializer();
        var b = a.toJson(this);
        return b;
    };
    Fdc3Context.$t = markType(Fdc3Context, 'Fdc3Context', Fdc3Dictionary.$);
    return Fdc3Context;
}(Fdc3Dictionary));
export { Fdc3Context };
/**
 * @hidden
 */
var Fdc3Instrument = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Instrument, _super);
    function Fdc3Instrument() {
        return _super.call(this, 1, 1) || this;
    }
    Object.defineProperty(Fdc3Instrument.prototype, "ticker", {
        get: function () {
            return this.id.item("ticker").toString();
        },
        set: function (a) {
            this.id.item("ticker", a);
        },
        enumerable: false,
        configurable: true
    });
    Fdc3Instrument.$t = markType(Fdc3Instrument, 'Fdc3Instrument', Fdc3Context.$);
    return Fdc3Instrument;
}(Fdc3Context));
export { Fdc3Instrument };
/**
 * @hidden
 */
var Fdc3InstrumentList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3InstrumentList, _super);
    function Fdc3InstrumentList() {
        var _this = _super.call(this, 0) || this;
        _this._instruments = null;
        _this.type = Fdc3Util.getString(2);
        _this.instruments = new Array(0);
        return _this;
    }
    Object.defineProperty(Fdc3InstrumentList.prototype, "instruments", {
        get: function () {
            return this._instruments;
        },
        set: function (a) {
            this._instruments = a;
        },
        enumerable: false,
        configurable: true
    });
    Fdc3InstrumentList.$t = markType(Fdc3InstrumentList, 'Fdc3InstrumentList', Fdc3Context.$);
    return Fdc3InstrumentList;
}(Fdc3Context));
export { Fdc3InstrumentList };
/**
 * @hidden
 */
var Fdc3Position = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Position, _super);
    function Fdc3Position() {
        var _this = _super.call(this, 1, 3) || this;
        _this.instrument = new Fdc3Instrument();
        return _this;
    }
    Object.defineProperty(Fdc3Position.prototype, "instrument", {
        get: function () {
            return typeCast(Fdc3Instrument.$, this.item("instrument"));
        },
        set: function (a) {
            this.item("instrument", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Position.prototype, "shares", {
        get: function () {
            return this.e("shares");
        },
        set: function (a) {
            this.item("shares", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Position.prototype, "cost", {
        get: function () {
            return this.e("cost");
        },
        set: function (a) {
            this.item("cost", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Position.prototype, "price", {
        get: function () {
            return this.e("price");
        },
        set: function (a) {
            this.item("price", a);
        },
        enumerable: false,
        configurable: true
    });
    Fdc3Position.$t = markType(Fdc3Position, 'Fdc3Position', Fdc3Context.$);
    return Fdc3Position;
}(Fdc3Context));
export { Fdc3Position };
/**
 * @hidden
 */
var Fdc3Portfolio = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Portfolio, _super);
    function Fdc3Portfolio() {
        var _this = _super.call(this, 1, 4) || this;
        _this._positions = null;
        _this.positions = new Array(0);
        return _this;
    }
    Object.defineProperty(Fdc3Portfolio.prototype, "positions", {
        get: function () {
            return this._positions;
        },
        set: function (a) {
            this._positions = a;
        },
        enumerable: false,
        configurable: true
    });
    Fdc3Portfolio.$t = markType(Fdc3Portfolio, 'Fdc3Portfolio', Fdc3Context.$);
    return Fdc3Portfolio;
}(Fdc3Context));
export { Fdc3Portfolio };
/**
 * @hidden
 */
var Fdc3Organization = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Organization, _super);
    function Fdc3Organization() {
        return _super.call(this, 1, 7) || this;
    }
    Fdc3Organization.$t = markType(Fdc3Organization, 'Fdc3Organization', Fdc3Context.$);
    return Fdc3Organization;
}(Fdc3Context));
export { Fdc3Organization };
/**
 * @hidden
 */
var Fdc3OrganizationList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3OrganizationList, _super);
    function Fdc3OrganizationList() {
        var _this = _super.call(this, 1, 8) || this;
        _this._organizations = null;
        return _this;
    }
    Object.defineProperty(Fdc3OrganizationList.prototype, "organizations", {
        get: function () {
            return this._organizations;
        },
        set: function (a) {
            this._organizations = a;
        },
        enumerable: false,
        configurable: true
    });
    Fdc3OrganizationList.$t = markType(Fdc3OrganizationList, 'Fdc3OrganizationList', Fdc3Context.$);
    return Fdc3OrganizationList;
}(Fdc3Context));
export { Fdc3OrganizationList };
/**
 * @hidden
 */
var Fdc3Contact = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Contact, _super);
    function Fdc3Contact(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = ["", "", "", ""];
                    {
                        var e = c[0];
                        var f = c[1];
                        var g = c[2];
                        var h = c[3];
                        _this = _super.call(this, 1, 5) || this;
                        _this.name = e;
                        _this.email = f;
                        _this.phone = g;
                        _this.twitter = h;
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    _this = _super.call(this, 1, 5) || this;
                    _this.name = c;
                    _this.email = d;
                    _this.phone = e;
                    _this.twitter = f;
                }
                break;
        }
        return _this;
    }
    Object.defineProperty(Fdc3Contact.prototype, "email", {
        get: function () {
            return this.id.item("email").toString();
        },
        set: function (a) {
            this.id.item("email", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Contact.prototype, "phone", {
        get: function () {
            return this.id.item("phone").toString();
        },
        set: function (a) {
            this.id.item("phone", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Contact.prototype, "twitter", {
        get: function () {
            return this.id.item("twitter").toString();
        },
        set: function (a) {
            this.id.item("twitter", a);
        },
        enumerable: false,
        configurable: true
    });
    Fdc3Contact.$t = markType(Fdc3Contact, 'Fdc3Contact', Fdc3Context.$);
    return Fdc3Contact;
}(Fdc3Context));
export { Fdc3Contact };
/**
 * @hidden
 */
var Fdc3ContactList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3ContactList, _super);
    function Fdc3ContactList(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    _this = _super.call(this, 1, 6) || this;
                    _this._contacts = null;
                    _this.contacts = new Array(0);
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    {
                        _this = _super.call(this, 1, 6) || this;
                        _this._contacts = null;
                        _this.contacts = new Array(0);
                    }
                    _this.contacts = c;
                }
                break;
        }
        return _this;
    }
    Object.defineProperty(Fdc3ContactList.prototype, "contacts", {
        get: function () {
            return this._contacts;
        },
        set: function (a) {
            this._contacts = a;
        },
        enumerable: false,
        configurable: true
    });
    Fdc3ContactList.$t = markType(Fdc3ContactList, 'Fdc3ContactList', Fdc3Context.$);
    return Fdc3ContactList;
}(Fdc3Context));
export { Fdc3ContactList };
