/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, callStaticConstructors, String_$type, EnumUtil, markType } from "igniteui-webcomponents-core";
import { Dictionary$2 } from "igniteui-webcomponents-core";
import { Fdc3ContextType_$type } from "./Fdc3ContextType";
import { Fdc3IntentType_$type } from "./Fdc3IntentType";
/**
 * @hidden
 */
var Fdc3Util = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Util, _super);
    function Fdc3Util() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Fdc3Util.staticInit = function () {
        Fdc3Util.c = new Dictionary$2(String_$type, Fdc3ContextType_$type, 0);
        Fdc3Util.f(0);
        Fdc3Util.f(1);
        Fdc3Util.f(2);
        Fdc3Util.f(3);
        Fdc3Util.f(4);
        Fdc3Util.f(7);
        Fdc3Util.f(8);
        Fdc3Util.f(5);
        Fdc3Util.f(6);
        Fdc3Util.d = new Dictionary$2(String_$type, Fdc3IntentType_$type, 0);
        Fdc3Util.g(2);
        Fdc3Util.g(3);
        Fdc3Util.g(4);
        Fdc3Util.g(7);
        Fdc3Util.g(5);
        Fdc3Util.g(6);
        Fdc3Util.g(8);
        Fdc3Util.g(10);
        Fdc3Util.g(9);
    };
    Fdc3Util.getString = function (a) {
        var b = EnumUtil.getName(Fdc3ContextType_$type, a);
        return "fdc3." + b.substr(0, 1).toLowerCase() + b.substr(1);
    };
    Fdc3Util.a = function (a) {
        if (Fdc3Util.c.containsKey(a)) {
            return Fdc3Util.c.item(a);
        }
        else {
            return 0;
        }
    };
    Fdc3Util.b = function (a) {
        if (Fdc3Util.d.containsKey(a)) {
            return Fdc3Util.d.item(a);
        }
        else {
            return 2;
        }
    };
    Fdc3Util.f = function (a) {
        var b = Fdc3Util.getString(a);
        if (!Fdc3Util.c.containsKey(b)) {
            Fdc3Util.c.addItem(b, a);
        }
    };
    Fdc3Util.g = function (a) {
        var b = EnumUtil.getName(Fdc3IntentType_$type, a);
        if (!Fdc3Util.d.containsKey(b)) {
            Fdc3Util.d.addItem(b, a);
        }
    };
    Fdc3Util.$t = markType(Fdc3Util, 'Fdc3Util');
    Fdc3Util.c = null;
    Fdc3Util.d = null;
    return Fdc3Util;
}(Base));
export { Fdc3Util };
(function (v) { callStaticConstructors(); })(true);
