import { Base, Type } from "igniteui-webcomponents-core";
import { Fdc3Instrument } from "./Fdc3Instrument";
import { Fdc3InstrumentList } from "./Fdc3InstrumentList";
import { Fdc3Position } from "./Fdc3Position";
import { Fdc3Portfolio } from "./Fdc3Portfolio";
/**
 * @hidden
 */
export declare class Fdc3Converter extends Base {
    static $t: Type;
    static log(message_: string): void;
    static toInstrument(context_: any): Fdc3Instrument;
    static toInstrumentList(context_: any): Fdc3InstrumentList;
    static toPosition(context_: any): Fdc3Position;
    static toPortfolio(context_: any): Fdc3Portfolio;
    static fromPortfolio(portfolio_: Fdc3Portfolio): any;
    static fromPosition(position_: Fdc3Position): any;
    static fromInstrumentList(list_: Fdc3InstrumentList): any;
    static fromInstrument(instrument_: Fdc3Instrument): any;
}
